clear
clc

load C:\ag562\Dropbox\search\solx_revall16_step2.mat solx1



b = solx1;




lambda      = exp(b(1));
gamma_s     = exp(b(2));
gamma_sd    = exp(b(3));
alpha_ds    = exp(b(4));

delta2      = exp(b(5)); 
zh          = exp(b(6)); %zh = 650000;
zl          = exp(b(7)); %zl = 300000;
cs          = exp(b(8)); %cs = 30000;
thetas      = exp(b(9))/(1+exp(b(9)));
thetad      = exp(b(10))/(1+exp(b(10))); 



load ident_th

f           = 12;
h           = 3;




minth = 1;
maxth = 20;


beta1 = (pr(1,minth:maxth)-pr(2,minth:maxth))/.0158;

beta4 = (pw(1,minth:maxth)-pw(2,minth:maxth))/.0157;

beta0 = pr(1,minth:maxth) - beta1;

beta3 = pw(1,minth:maxth) - beta4;


figure(1)
subplot(2,2,2)
plot(thgrid(minth:maxth),smooth(beta0),'b','linewidth',h)
hold on
plot(thgrid(minth:maxth),smooth(beta3),'r--','linewidth',h)
hold on
line(thetad*ones(9,1),[-2.6:.1:-1.8]*10^6','Color','k','LineWidth',h,'linestyle','-.')
hold off
set(gca,'xTick',[min(thgrid) .9 max(thgrid)],'XTickLabel',[.8 .9 1],'FontSize',f)
set(gca,'yTick',[-2.6 -2.2 -1.8]*10^6,'YTickLabel',[-2.6 -2.2 -1.8],'FontSize',f)
axis([thgrid(minth) max(thgrid) -2.6*10^6 -1.8*10^6])
xlabel('Dealers'' bargaining power $\theta_{d}$','FontSize',f)
ylabel('Price (millions)','FontSize',f)
grid on

subplot(2,2,1)

plot(thgrid(minth:maxth),smooth(pr(1,:)),'b','linewidth',h)
hold on
plot(thgrid(minth:maxth),smooth(pw(1,:)),'r--','linewidth',h)
hold on
line(thetad*ones(4,1),[15:1:18]*10^6','Color','k','LineWidth',h,'linestyle','-.')
hold off
set(gca,'xTick',[min(thgrid) .9 max(thgrid)],'XTickLabel',[.8 .9 1],'FontSize',f)
set(gca,'yTick',[1.5 1.65 1.8]*10^7,'YTickLabel',[15 16.5 18],'FontSize',f)
axis([min(thgrid) max(thgrid) 1.5*10^7 1.8*10^7])
xlabel('Dealers'' bargaining power $\theta_{d}$','FontSize',f)
ylabel('Price (millions)','FontSize',f)
grid on




load z_robust

minth = 4;
maxth = 7;


beta1 = (pr(1,minth:maxth)-pr(2,minth:maxth))/.0158;

beta4 = (pw(1,minth:maxth)-pw(2,minth:maxth))/.0157;

beta0 = pr(1,minth:maxth) - beta1;

beta3 = pw(1,minth:maxth) - beta4;

figure(1)
subplot(2,2,4)
plot(zgrid(minth:maxth),smooth(beta0),'b','linewidth',h)
hold on
plot(zgrid(minth:maxth),smooth(beta3),'r--','linewidth',h)
hold on
line((zh/zl)*ones(9,1),[-2.2:.1:-1.4]*10^6','Color','k','LineWidth',h,'linestyle','-.')
hold off
set(gca,'yTick',[-2.2 -1.8 -1.4]*10^6,'YTickLabel',[-2.2 -1.8 -1.4],'FontSize',f)
set(gca,'xTick',[minth 5.5 maxth],'XTickLabel',[minth 5.5 maxth],'FontSize',f)
axis([minth maxth -2.2*10^6 -1.4*10^6])
xlabel('Valuations $z_{h}/z_{l}$','FontSize',f)
ylabel('Price (millions)','FontSize',f)
grid on


subplot(2,2,3)
plot(zgrid(minth:maxth),smooth(pr(1,minth:maxth)),'b','linewidth',h)
hold on
plot(zgrid(minth:maxth),smooth(pw(1,minth:maxth)),'r--','linewidth',h)
hold on
line((zh/zl)*ones(21,1),[0:.1:2]*10^7','Color','k','LineWidth',h,'linestyle','-.')
hold off
set(gca,'yTick',[1 1.5 2.03]*10^7,'YTickLabel',[0 15 20],'FontSize',f)
set(gca,'xTick',[minth 5.5 maxth],'XTickLabel',[minth 5.5 maxth],'FontSize',f)
axis([minth maxth 1*10^7 2.03*10^7])
xlabel('Valuations $z_{h}/z_{l}$','FontSize',f)
ylabel('Price (millions)','FontSize',f)
grid on

%set(gca,'xTick',[min(thgrid) .9 max(thgrid)],'XTickLabel',[.8 .9 1],'FontSize',f)
%set(gca,'yTick',[15 16.5 18]*10^6,'YTickLabel',[15 16.5 18],'FontSize',f)
%axis([thgrid(minth) max(thgrid) 15*10^6 18*10^6])
%xlabel('','FontSize',f)
%ylabel('Price (millions)','FontSize',f)


laprint(1,'ident1','factor',.6,'scalefonts','off','keepfontprops','on','asonscreen','off')

pause(5)
dos('move c:\ag562\Dropbox\search\Revision2\ident1.eps c:\ag562\Dropbox\search\figures')

