%%%%%%%%%%%%%%%%%%%% This file does figure 5 %%%%%%%%%%%%%%%%%%%%%%%%%%%%


clear
clc

clf

f           = 7;
h           = 2;


load C:\ag562\Dropbox\search\solx_revall16_step2.mat solx1



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% fixed parameters

rho     =    .015; % quarterly data
delta1  =       1;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% second step

b = solx1;





lambda      = exp(b(1));
gamma_s     = exp(b(2));
gamma_sd    = exp(b(3));
alpha_ds    = exp(b(4));

delta2      = exp(b(5)); 
zh          = exp(b(6)); %zh = 650000;
zl          = exp(b(7)); %zl = 300000;
cs          = exp(b(8)); %cs = 30000;
thetas      = exp(b(9))/(1+exp(b(9)));
thetad      = exp(b(10))/(1+exp(b(10))); 




figure(5)

load z_robust.mat

md  = md_sol1.*(fval1 < 2000);

wf3 = wf1.*(fval1 > 2000) + wf2.*(fval1 < 2000);


subplot(6,2,1)
plot(zgrid(1,[1:16,18:20]),smooth(md(1,[1:16,18:20])),'b','linewidth',h)
hold on
line((zh/zl)*ones(9,1),[0:1000:8000]','Color','k','LineWidth',h,'linestyle','-.')
hold off

xlabel('Valuations $z_{h}/z_{l}$','FontSize',f)
ylabel('Dealers $\mu_{d}$','FontSize',f)
set(gca,'xTick',[min(zgrid) max(zgrid)/2 max(zgrid)],'XTickLabel',[1 10 20],'FontSize',f)
set(gca,'yTick',[0 4000 8000],'YTickLabel',[0 4000 8000],'FontSize',f)
axis([min(zgrid) max(zgrid) 0 8000])
grid on


subplot(6,2,2)
plot(zgrid(1,[1:16,18:20]),smooth(wf1(1,[1:16,18:20])./wf3(1,[1:16,18:20])),'b','linewidth',h)
hold on
line((zh/zl)*ones(9,1),[0:1000:8000]','Color','k','LineWidth',h,'linestyle','-.')
hold off

xlabel('Valuations $z_{h}/z_{l}$','FontSize',f)
ylabel('Relative welfare','FontSize',f)
set(gca,'xTick',[min(zgrid) max(zgrid)/2 max(zgrid)],'XTickLabel',[1 10 20],'FontSize',f)
set(gca,'yTick',[0.8 1 1.2],'YTickLabel',[0.8 1 1.2],'FontSize',f)
axis([min(zgrid) max(zgrid) 0.8 1.2])
grid on


load g_robust.mat

md  = md_sol1.*(fval1 < 1000);

wf3 = wf1.*(fval1 > 1000) + wf2.*(fval1 < 1000);

subplot(6,2,3)
plot(ggrid,md,'b','linewidth',h)
hold on
line(g0*ones(9,1),[0:1000:8000]','Color','k','LineWidth',h,'linestyle','-.')
hold off


xlabel('Pairwise meeting rate $\gamma''/\gamma$','FontSize',f)
ylabel('Dealers $\mu_{d}$','FontSize',f)
set(gca,'xTick',[min(ggrid) max(ggrid)/2 max(ggrid)],'XTickLabel',[1 50 100],'FontSize',f)
set(gca,'yTick',[0 1800 3600],'YTickLabel',[0 1800 3600],'FontSize',f)
axis([min(ggrid) max(ggrid) 0 3600])
grid on



subplot(6,2,4)
plot(ggrid,wf1./wf3,'b','linewidth',h)
hold on
line(g0*ones(9,1),[0:1000:8000]','Color','k','LineWidth',h,'linestyle','-.')
hold off


ylabel('Relative welfare','FontSize',f)
xlabel('Pairwise meeting rate $\gamma''/\gamma$','FontSize',f)
set(gca,'xTick',[min(ggrid) max(ggrid)/2 max(ggrid)],'XTickLabel',[1 50 100],'FontSize',f)
set(gca,'yTick',[0.8 1 1.2],'YTickLabel',[0.8 1 1.2],'FontSize',f)
axis([min(ggrid) max(ggrid) 0.8 1.2])
grid on



load l_robust.mat

md  = md_sol1.*(fval1 < 1000);

wf3 = wf1.*(fval1 > 1000) + wf2.*(fval1 < 1000);

subplot(6,2,5)
plot(lgrid,md,'b','linewidth',h)
hold on
line(lambda*ones(7,1),[0:1000:6000]','Color','k','LineWidth',h,'linestyle','-.')
hold off


xlabel('Switching rate $\lambda$','FontSize',f)
ylabel('Dealers $\mu_{d}$','FontSize',f)
set(gca,'xTick',[min(lgrid) max(lgrid)/2 max(lgrid)],'XTickLabel',[min(lgrid) max(lgrid)/2 max(lgrid)],'FontSize',f)
set(gca,'yTick',[0 3000 6000],'YTickLabel',[0 3000 6000],'FontSize',f)
axis([min(lgrid) max(lgrid) 0 6000])
grid on


subplot(6,2,6)
plot(lgrid,wf1./wf3,'b','linewidth',h)
hold on
line(lambda*ones(7,1),[0:1000:6000]','Color','k','LineWidth',h,'linestyle','-.')
hold off
ylabel('Relative welfare','FontSize',f)
xlabel('Switching rate $\lambda$','FontSize',f)
set(gca,'xTick',[min(lgrid) max(lgrid)/2 max(lgrid)],'XTickLabel',[min(lgrid) max(lgrid)/2 max(lgrid)],'FontSize',f)
set(gca,'yTick',[0.3 1 1.7],'YTickLabel',[0.3 1 1.7],'FontSize',f)
axis([min(lgrid) max(lgrid) 0.3 1.7])
grid on



load th_robust.mat

md  = md_sol1.*(fval1 < 1000);

wf3 = wf1.*(fval1 > 1000) + wf2.*(fval1 < 1000);

subplot(6,2,7)
plot(thgrid,md,'b','linewidth',h)
hold on
line(thetad*ones(11,1),[0:100:1000]','Color','k','LineWidth',h,'linestyle','-.')
hold off
xlabel('Dealers'' bargaining power $\theta_{d}$','FontSize',f)
ylabel('Dealers $\mu_{d}$','FontSize',f)
set(gca,'xTick',[min(thgrid) max(thgrid)/2 max(thgrid)],'XTickLabel',[0 0.5 1],'FontSize',f)
set(gca,'yTick',[0 500 1000],'YTickLabel',[0 500 1000],'FontSize',f)
axis([min(thgrid) max(thgrid) 0 1000])
grid on



subplot(6,2,8)
plot(thgrid,wf1./wf3,'b','linewidth',h)
hold on
line(thetad*ones(11,1),[0:100:1000]','Color','k','LineWidth',h,'linestyle','-.')
hold off
xlabel('Dealers'' bargaining power $\theta_{d}$','FontSize',f)
ylabel('Relative welfare','FontSize',f)
set(gca,'xTick',[min(thgrid) max(thgrid)/2 max(thgrid)],'XTickLabel',[0 0.5 1],'FontSize',f)
set(gca,'yTick',[0.8 1 1.2],'YTickLabel',[0.8 1 1.2],'FontSize',f)
axis([min(thgrid) max(thgrid) 0.8 1.2])
grid on




load c_robust.mat

md  = md_sol1.*(fval1 < 1000);

wf3 = wf1.*(fval1 > 1000) + wf2.*(fval1 < 1000);

subplot(6,2,9)
plot(cgrid,smooth(md),'b','linewidth',h)
hold on
line(cs*ones(11,1),[0:200:2000]','Color','k','LineWidth',h,'linestyle','-.')
hold off
xlabel('Search cost $c_{s}$','FontSize',f)
ylabel('Dealers $\mu_{d}$','FontSize',f)
set(gca,'xTick',[min(cgrid) max(cgrid)/2 max(cgrid)],'XTickLabel',[min(cgrid) max(cgrid)/2 max(cgrid)],'FontSize',f)
set(gca,'yTick',[1000 1500 2000],'YTickLabel',[1000 1500 2000],'FontSize',f)
axis([min(cgrid) max(cgrid) 1000 2000])
grid on



subplot(6,2,10)
plot(cgrid,smooth(wf1./wf3),'b','linewidth',h)
hold on
line(cs*ones(11,1),[0:200:2000]','Color','k','LineWidth',h,'linestyle','-.')
hold off
xlabel('Search cost $c_{s}$','FontSize',f)
ylabel('Relative welfare','FontSize',f)
set(gca,'xTick',[min(cgrid) max(cgrid)/2 max(cgrid)],'XTickLabel',[min(cgrid) max(cgrid)/2 max(cgrid)],'FontSize',f)
set(gca,'yTick',[0.8 0.9 1],'YTickLabel',[0.8 0.9 1],'FontSize',f)
axis([min(cgrid) max(cgrid) 0.8 1])
grid on



load k_robust.mat

md  = md_sol1.*(fval1 < 1000);

wf3 = wf1.*(fval1 > 1000) + wf2.*(fval1 < 1000);

subplot(6,2,11)
plot(kgrid,md,'b','linewidth',h)
hold on
line(kgrid(10)*ones(11,1),[0:2000:20000]','Color','k','LineWidth',h,'linestyle','-.')
hold off

xlabel('Dealers'' cost $k$','FontSize',f)
ylabel('Dealers $\mu_{d}$','FontSize',f)
set(gca,'xTick',[min(kgrid) max(kgrid)/2 max(kgrid)],'XTickLabel',[min(kgrid) max(kgrid)/2 max(kgrid)],'FontSize',f)
set(gca,'yTick',[0 10000 20000],'YTickLabel',[0 10000 20000],'FontSize',f)
axis([min(kgrid) max(kgrid) 0 20000])
grid on

subplot(6,2,12)
plot(kgrid,wf1./wf3,'b','linewidth',h)
hold on
line(kgrid(10)*ones(11,1),[0:2000:20000]','Color','k','LineWidth',h,'linestyle','-.')
hold off
xlabel('Dealers'' cost $k$','FontSize',f)
ylabel('Relative welfare','FontSize',f)
set(gca,'xTick',[min(kgrid) max(kgrid)/2 max(kgrid)],'XTickLabel',[min(kgrid) max(kgrid)/2 max(kgrid)],'FontSize',f)
set(gca,'yTick',[0.8 1 1.2],'YTickLabel',[0.8 1 1.2],'FontSize',f)
axis([min(kgrid) max(kgrid) 0.8 1.2])
grid on

laprint(5,'robust1','factor',.55,'scalefonts','off','keepfontprops','on',...
    'keepticklabels','off','mathticklabels','off','asonscreen','off')
pause(5)
dos('move c:\ag562\Dropbox\search\Revision2\robust1.eps c:\ag562\Dropbox\search\figures')

return


figure(5)

load z_robust2.mat

md  = md_sol1.*(fval1 < 1000);

wf3 = wf1.*(fval1 > 1000) + wf2.*(fval1 < 1000);

subplot(5,2,1)
plot(zgrid,md,'b','linewidth',h)

xlabel('Valuations $z_{h}-z_{l}$','FontSize',f)
ylabel('Dealers $\mu_{d}$','FontSize',f)
set(gca,'xTick',[min(zgrid) max(zgrid)/2 max(zgrid)],'XTickLabel',[min(zgrid) max(zgrid)/2 max(zgrid)],'FontSize',f)
set(gca,'yTick',[-100 0 100],'YTickLabel',[-100 0 100],'FontSize',f)
axis([min(zgrid) max(zgrid) -100 100])
grid on


subplot(5,2,2)
plot(zgrid,wf1./wf3,'b','linewidth',h)

xlabel('Valuations $z_{h}-z_{l}$','FontSize',f)
ylabel('Relative welfare','FontSize',f)
set(gca,'xTick',[min(zgrid) max(zgrid)/2 max(zgrid)],'XTickLabel',[min(zgrid) max(zgrid)/2 max(zgrid)],'FontSize',f)
set(gca,'yTick',[0.9 1 1.1],'YTickLabel',[0.9 1 1.1],'FontSize',f)
axis([min(zgrid) max(zgrid) 0.9 1.1])
grid on


load g_robust2.mat

md  = md_sol1.*(fval1 < 1000);

wf3 = wf1.*(fval1 > 1000) + wf2.*(fval1 < 1000);

subplot(5,2,3)
plot(ggrid,md,'b','linewidth',h)
xlabel('$\gamma^''-\gamma$','FontSize',f)
ylabel('Dealers $\mu_{d}$','FontSize',f)
set(gca,'xTick',[min(ggrid) max(ggrid)/2 max(ggrid)],'XTickLabel',[min(ggrid) max(ggrid)/2 max(ggrid)],'FontSize',f)
set(gca,'yTick',[0 300 600],'YTickLabel',[0 300 600],'FontSize',f)
axis([min(ggrid) max(ggrid) 0 600])
grid on



subplot(5,2,4)
plot(ggrid,wf1./wf3,'b','linewidth',h)
ylabel('Relative welfare','FontSize',f)
xlabel('$\gamma^''-\gamma$','FontSize',f)
set(gca,'xTick',[min(ggrid) max(ggrid)/2 max(ggrid)],'XTickLabel',[min(ggrid) max(ggrid)/2 max(ggrid)],'FontSize',f)
set(gca,'yTick',[0.9 1 1.1],'YTickLabel',[0.9 1 1.1],'FontSize',f)
axis([min(ggrid) max(ggrid) 0.9 1.1])
grid on



load l_robust2.mat

md  = md_sol1.*(fval1 < 1000);

wf3 = wf1.*(fval1 > 1000) + wf2.*(fval1 < 1000);

subplot(5,2,5)
plot(lgrid,md,'b','linewidth',h)
xlabel('$\lambda$','FontSize',f)
ylabel('Dealers $\mu_{d}$','FontSize',f)
set(gca,'xTick',[min(lgrid) max(lgrid)/2 max(lgrid)],'XTickLabel',[min(lgrid) max(lgrid)/2 max(lgrid)],'FontSize',f)
set(gca,'yTick',[-100 0 100],'YTickLabel',[-100 0 100],'FontSize',f)
axis([min(lgrid) max(lgrid) -100 100])
grid on



subplot(5,2,6)
plot(lgrid,wf1./wf3,'b','linewidth',h)
ylabel('Relative welfare','FontSize',f)
xlabel('$\lambda$','FontSize',f)
set(gca,'xTick',[min(lgrid) max(lgrid)/2 max(lgrid)],'XTickLabel',[min(lgrid) max(lgrid)/2 max(lgrid)],'FontSize',f)
set(gca,'yTick',[0.9 1 1.1],'YTickLabel',[0.9 1 1.1],'FontSize',f)
axis([min(lgrid) max(lgrid) 0.9 1.1])
grid on



load c_robust2.mat

md  = md_sol1.*(fval1 < 1000);

wf3 = wf1.*(fval1 > 1000) + wf2.*(fval1 < 1000);

subplot(5,2,7)
plot(cgrid,md,'b','linewidth',h)
xlabel('$c_{s}$','FontSize',f)
ylabel('Dealers $\mu_{d}$','FontSize',f)
set(gca,'xTick',[min(cgrid) max(cgrid)/2 max(cgrid)],'XTickLabel',[min(cgrid) max(cgrid)/2 max(cgrid)],'FontSize',f)
set(gca,'yTick',[-100 0 100],'YTickLabel',[-100 0 100],'FontSize',f)
axis([min(cgrid) max(cgrid) -100 100])
grid on



subplot(5,2,8)
plot(cgrid,wf1./wf3,'b','linewidth',h)
xlabel('$c_{s}$','FontSize',f)
ylabel('Relative welfare','FontSize',f)
set(gca,'xTick',[min(cgrid) max(cgrid)/2 max(cgrid)],'XTickLabel',[0 0.5 1],'FontSize',f)
set(gca,'yTick',[0.9 1 1.1],'YTickLabel',[0.9 1 1.1],'FontSize',f)
axis([min(cgrid) max(cgrid) 0.9 1.1])

grid on



load k_robust2.mat

md  = md_sol1.*(fval1 < 1000);

wf3 = wf1.*(fval1 > 1000) + wf2.*(fval1 < 1000);

subplot(5,2,9)
plot(kgrid,md,'b','linewidth',h)
xlabel('$k$','FontSize',f)
ylabel('Dealers $\mu_{d}$','FontSize',f)
set(gca,'xTick',[min(kgrid) max(kgrid)/2 max(kgrid)],'XTickLabel',[min(kgrid) max(kgrid)/2 max(kgrid)],'FontSize',f)
set(gca,'yTick',[0 1250 2500],'YTickLabel',[0 1250 2500],'FontSize',f)
axis([min(kgrid) max(kgrid) 0 2500])
grid on

subplot(5,2,10)
plot(kgrid,wf1./wf3,'b','linewidth',h)
xlabel('$k$','FontSize',f)
ylabel('Relative welfare','FontSize',f)
set(gca,'xTick',[min(kgrid) max(kgrid)/2 max(kgrid)],'XTickLabel',[min(kgrid) max(kgrid)/2 max(kgrid)],'FontSize',f)
set(gca,'yTick',[0.9 1 1.1],'YTickLabel',[0.9 1 1.1],'FontSize',f)
axis([min(kgrid) max(kgrid) 0.9 1.1])
grid on
