%%%%%%%%%%%%%%%%%%%%% This file does the first step estimation %%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc
clear

warning off


addpath(genpath('/scratch/gavazza/jplv7'))
cd /scratch/gavazza/search/


options  = optimset('Display','iter','MaxFunEvals',20000,'MaxIter',10000);



load solx_revall16.mat solx1 fval1


solx0 = solx1;

%%%%%%%%%%%%%

maxt = 120;
imax = 100;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% fixed parameters
rho     =    .015; % quarterly data
delta1  =       1;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Infile data %%%%%%%%%%%%%%
[avgage, forsale, active, rtrans, dtrans, deal_inv, tdate, make_model] = textread('samplest_rev1.txt', '%n %n %n %n %n %n %n %n','delimiter',',');


[pr, pw, dpr, dpw, qage] = textread('pricev2_2.txt', '%n %n %n %n %n','delimiter',',','emptyvalue',999);


data_p = [pr, pw, dpr, dpw, qage];

data_p = data_p(qage<=maxt,:);

pr = data_p(:,1);

pw = data_p(:,2);

qage = data_p(:,5);


data_q = [forsale, deal_inv, (rtrans-dtrans), dtrans, avgage, active];

[nobsq,nvarsq] = size(data_q);


lpr = log(pr);
lpw = log(pw);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% price regressions
p_data = [pr;pw];

nl = length(p_data);

dummy_pw = [zeros(nl/2,1);ones(nl/2,1)];

qagevec = [qage;qage];

x = [dummy_pw,qagevec];



beta0 = [-2542121;2542121+(-2440869);2.01e+07;-2.01e+07+1.80e+07;.0151;0];

beta = fminsearch('pnlfit',beta0,options,p_data,x);



modelfun = @(b,x) (b(1)+b(2)*x(:,1)) + (b(3)+b(4)*x(:,1)).*exp(-(b(5)+b(6)*x(:,1)).*x(:,2));

opts                   = statset('nlinfit');
opts.Display           = 'off';
opts.MaxIter           = 1000;

x = [dummy_pw,qagevec];

beta0 = beta;
[beta1,R,J,cov_beta] = nlinfit(x,p_data,modelfun,beta0,opts);

beta_vec = [beta1(1)+beta1(3);beta1(1)+beta1(2)+beta1(3)+beta1(4);beta1(3);beta1(3)+beta1(4);beta1(5);beta1(5)+beta1(6)];

for i = 1:1:maxt+1
    pr_m(i) = mean(pr(qage==i-1));
    
end

pr_s = beta1(1) + beta1(3).*exp(-beta1(5).*(0:1:maxt));

A           = 9687;
md          = 1000; 
k0          = 150000;
tf          = 160;

rdtrans     = rtrans-dtrans;

vc = diag(ones(11,1));  

%%%%%%%%%%%%%%%%%%%%%%% first step

weights = active;



% first step estimation using diagonal weighting matrix

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



options  = optimset('Display','iter','MaxFunEvals',20000,'MaxIter',60,'TolX',1e-5);
fval0 = 10;
fval1 = 5;

while fval0-fval1>0

fval0 = fval1;

[solx1,fval1]  = fminsearch('mp_new23',solx0,options,forsale,deal_inv,dtrans,rdtrans,avgage,active,A,md,...
                            beta_vec,maxt,imax,k0,tf,rho,vc,weights,opts);

pause(rand)


solx0       = solx1;
                      
                        
save solx_revall16.mat solx1 

                        
end



disp('first step completed')





