%%%%%%%%%%%%%%%%%%%%% This file does the second step estimation %%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc
clear

warning off

addpath(genpath('/scratch/gavazza/jplv7'))
cd /scratch/gavazza/search/


opts                = statset('nlinfit');
opts.Display        = 'off';


options   = optimset('Display','iter','MaxFunEvals',20000,'MaxIter',150);
options2  = optimset('Display','off','MaxFunEvals',20000,'MaxIter',5000);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  loading first step parameters

load solx_revall16.mat solx1 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% fixed parameters
rho     =    .015; % quarterly data
delta1  =       1;

maxt = 120;
imax = 100;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Infile data %%%%%%%%%%%%%%
[avgage, forsale, active, rtrans, dtrans, deal_inv, tdate, make_model] = textread('samplest_rev1.txt', '%n %n %n %n %n %n %n %n','delimiter',',');


[pr, pw, dpr, dpw, qage] = textread('pricev2_2.txt', '%n %n %n %n %n','delimiter',',','emptyvalue',999);




data_q = [forsale, deal_inv, (rtrans-dtrans), dtrans, avgage, active];

[nobsq,nvarsq] = size(data_q);

data_p = [pr, pw, dpr, dpw, qage];

data_p = data_p(qage<=maxt,:);

pr = data_p(:,1);

pw = data_p(:,2);

qage = data_p(:,5);

[nobsp,nvarsp] = size(data_p);

size(pr)

lpr = log(pr);
lpw = log(pw);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% price regressions
p_data = [pr;pw];

nl = length(p_data);

dummy_pw = [zeros(nl/2,1);ones(nl/2,1)];

qagevec = [qage;qage];

x = [dummy_pw,qagevec];



beta0 = [-2542121;2542121+(-2440869);2.01e+07;-2.01e+07+1.80e+07;.0151;0];

beta = fminsearch('pnlfit',beta0,options2,p_data,x);





modelfun = @(b,x) (b(1)+b(2)*x(:,1)) + (b(3)+b(4)*x(:,1)).*exp(-(b(5)+b(6)*x(:,1)).*x(:,2));



x = [dummy_pw,qagevec];

beta0 = beta;
[beta1,R,J,cov_beta] = nlinfit(x,p_data,modelfun,beta0,opts);



beta_vec = [beta1(1)+beta1(3);beta1(1)+beta1(2)+beta1(3)+beta1(4);beta1(3);beta1(3)+beta1(4);beta1(5);beta1(5)+beta1(6)];



A           = 9687;
md          = 1000; 
k0          = 150000;
tf          = 160;

rdtrans     = rtrans-dtrans;

vc = diag(ones(11,1));  

                        
% parameter solutions from first-step estimation
 
b = solx1;


t0 = 0;


lambda      = exp(b(1));
gamma_s     = exp(b(2));
gamma_sd    = exp(b(3));
alpha_ds    = exp(b(4));

delta2      = exp(b(5)); 
zh          = exp(b(6)); 
zl          = exp(b(7)); 
cs          = exp(b(8));
thetas      = exp(b(9))/(1+exp(b(9)));
thetad      = exp(b(10))/(1+exp(b(10)));

b_first = b;

tspan1 = t0:1:tf;
tspan1 = tspan1';



a1 = ones(length(tspan1),1);
a2 = a1;
a3 = a1;
a4 = a1;
a5 = a1;
a6 = a1;


flowx = A/tf;



mdo = zeros(tf+1,1); mlo = zeros(tf+1,1);

mho(2:tf+1,1) = flowx - mdo(2:tf+1) - mlo(2:tf+1);

mho(1) = flowx; mlo(1) = 0; mdo(1) = 0; 


mdn         = max(md - sum(mdo),0);




tspan2 = tf+t0-tspan1;
tspan2 = tspan2';




jdn_m    = 0;
vln_m    = 0;
pscrap   = 0;

delta1 = 1; delta0 = 0;

    d3 = 100; d4 = 100; d5 = 100;
    i  = 0; 

    options1 = [];
 



 
       while (d3>0.005 || d4>.01) && i<imax 

            aa1 = flipdim(a1,1); aa2 = flipdim(a2,1); aa3 = flipdim(a3,1); 
            aa4 = flipdim(a4,1); aa5 = flipdim(a5,1); aa6 = flipdim(a6,1); 

            %scraph = min(max(find(aa2==1)),tf);
            %scrapd = min(max(find(aa5==1)),tf);

            gammaprime  = gamma_sd / mdn;
            mhn         = alpha_ds / gammaprime;
            gamma       = gamma_s  / mhn;        



            mho2 = mho;
            mlo2 = mlo;


            X1 = [0 flowx]';
            
            [t1,y1]=ode45(@masses6,tspan1,X1,options1,mhn,gamma_s,gamma_sd,...
                          flowx,gamma,gammaprime,lambda,aa1,aa2,aa3,aa4,aa5,aa6,tf);

            mho = y1(:,2).*aa2; mlo = y1(:,1); mdo = max((flowx - mlo - mho).*aa5,0);



            scraph = min(max(find(mho>0)),tf);
            %scrapd = min(max(find(mdo>0)),tf);




            gamma_b  = gamma*mlo.*aa1;
            gamma_bd = gammaprime*mdo.*aa5;
            alpha_db = gammaprime*mlo.*aa1;

            mdn  = max(md - sum(mdo),0);



            gamma_bb  = flipdim(gamma_b,1);  gamma_bdd = flipdim(gamma_bd,1); 
            alpha_dbb = flipdim(alpha_db,1);

            d0 = 100; d4 = 100; 
            i2 = 0;

            vhn_calc = 0;



            while d0>0.005 && i2<imax  


            vhn_m = vhn_calc; k = k0;
            %%%%% terminal condition
            X0 = [0 0 0 0 vhn_m+pscrap pscrap jdn_m+pscrap]';


            [t2,y2]=ode45(@fun_my4,tspan2,X0,options1, lambda, gamma_s, gamma_sd, ...
                          alpha_ds, delta0, delta1, delta2, zh, zl, vhn_m, cs, pscrap, k0, rho, thetas, thetad);

            p  = (1-thetas)*(y2(:,6) - vln_m) + thetas*(y2(:,5) - vhn_m);
            pb = (1-thetad)*(y2(:,7) - jdn_m) + thetad*(y2(:,6) - vln_m);
            pa = (1-thetad)*(y2(:,7) - jdn_m) + thetad*(y2(:,5) - vhn_m);
            


            vhn_calc  = (- cs  + sum(gamma_bb  .* max(y2(:,5) - p  - vhn_m,0)) ...
                               + sum(gamma_bdd .* max(y2(:,5) - pa - vhn_m,0))) /(rho+lambda);

            k0        =   sum (alpha_dbb.* max(y2(:,7) - pb- jdn_m,0));


            d1 = [abs(vhn_calc./vhn_m-1),abs((k0+1)./(k+1)-1),any(isnan(p)),isnan(vhn_calc),isnan(k0)];
            
            d0 = max([d1,isnan(d1)]);
            
            d4 = min(d4,d0);
            
            if d4 == d0
                
            vhn_m1 = vhn_calc;
            
            a1 = (y2(:,2) >= y2(:,3));
            a2 = (y2(:,1) >= pscrap*ones(length(t2),1)+vhn_m1);
            a3 = (y2(:,5) - pa - vhn_m1>=0);
            a4 = (y2(:,7) - pb - jdn_m>=0);
            a5 = (y2(:,7) >= (pscrap+jdn_m)*ones(length(t2),1));
            a6 = (y2(:,5) - p - vhn_m1>=0);
            
            p1  = p;
            pb1 = pb;
            k1  = k0;
            
            end
 
            i2=i2+1;



            end
            
            
       
            
            s1 = scraph;
            d2 = [mean(abs(mlo(2:s1)./mlo2(2:s1)-1)),mean(abs(mho(1:s1)./mho2(1:s1)-1)),...
                  sum(isnan(mlo)),sum(isnan(mho)),100*isempty(s1),100*isnan(s1)];
              
            d3 = min(100,max(d2));
            
            d5 = min(d5,d3);
            
            if d5 == d3 
                mho1 = mho; mhn1 = mhn; mlo1 = mlo; mdo1 = mdo; a11 = a1; k11 = k1; p11 = p1; pb11 = pb1;
            end

            i = i+1;
            
       end
        

    
    
mho = mho1; mhn = mhn1; mlo = mlo1; mdo = mdo1; p = p11; pb = pb11;  a1 = a11; k = k11;
                   
mu = lambda*(sum(mho) + mhn);




pp  = flipdim(p,1);
ppb = flipdim(pb,1);

aa1 = flipdim(a1,1);

mlo_fors = mlo.*aa1;

assets = sum(mlo+mdo+mho);     



%%%%%%%%% simulate prices
pr_sim = pp(1:maxt+1);
pw_sim = ppb(1:maxt+1);

p_sim = [pr_sim;pw_sim];


nl = length(p_sim);

dummy_sim = [zeros(nl/2,1);ones(nl/2,1)];

qagevec_sim = [(0:1:maxt)';(0:1:maxt)'];

x_sim = [dummy_sim,qagevec_sim];

beta0 = [beta_vec(1) - beta_vec(3);  beta_vec(2) - beta_vec(1) - beta_vec(3) - beta_vec(4); ...
         beta_vec(3); - beta_vec(3) + beta_vec(4); beta_vec(5); -beta_vec(5)+beta_vec(6)];


beta_sim = fminsearch('pnlfit',beta0,options2,p_sim,x_sim);
beta_sim = fminsearch('pnlfit',beta_sim,options2,p_sim,x_sim);
beta_sim = fminsearch('pnlfit',beta_sim,options2,p_sim,x_sim);



beta0 = beta_sim;
beta_sim = nlinfit(x_sim,p_sim,modelfun,beta0,opts);


beta_vec_sim = [beta_sim(1)+beta_sim(3);...
                beta_sim(1)+beta_sim(2)+beta_sim(3)+beta_sim(4);...
                beta_sim(3);...
                beta_sim(3)+beta_sim(4);...
                beta_sim(5);beta_sim(5)+beta_sim(6)];


%%%%%%%%%%%%%%%








constr = [(zh<zl);(vhn_calc<0);(cs>k);(mu/lambda<flowx*(tf+1))];


    

weights = active;    
vc = zeros(11,11);        


% second-step estimation with optimal weighting matrix including covariance

data_qp1 = [(forsale./active) / (sum(mlo_fors+mdo)/assets)                                   - 1, ...
            (deal_inv./active) / (sum(mdo)/assets)                                           - 1, ...
            (rdtrans./active) / (gamma_s*sum(mlo_fors)/assets)                               - 1, ...
            (dtrans./active) / (alpha_ds*sum(mdo)/assets)                                    - 1, ...
            avgage./(sum(tspan1.*(mlo_fors+mdo))/sum(mlo_fors+mdo))                          - 1];

        

        
vc(1:5,1:5) = weightedcov(data_qp1,weights);      

grad_vec = [1,1,0,0,0,0;...
            0,1,0,0,0,0;...
            1,1,1,1,0,0;...
            0,1,0,1,0,0;...
            0,0,0,0,1,1;...
            0,0,0,0,0,1];
        
Amat = ((1./beta_vec_sim)*ones(1,6))';        
    
cov_beta_p = (grad_vec.*Amat)'*cov_beta*(grad_vec.*Amat);
       


vc(6:11,6:11) = cov_beta_p; 

inv_vc = inv(vc);

g_first_step = [wmean(data_qp1,weights*ones(1,5))';(beta_vec./beta_vec_sim-1)];
f_first_step = sum(g_first_step.^2);





%%%%%%%%%%%%%%%%%%%%%%%%%%%% second step estimation

load solx_revall16_step2.mat solx1 

solx0 = solx1;

fval0 = 10e10;
fval1 = .5*fval0;

while fval0-fval1>0

fval0 = fval1;

[solx1,fval1]  = fminsearch('mp_new23',solx0,options,forsale,deal_inv,dtrans,rdtrans,avgage,active,A,md,...
                            beta_vec,maxt,imax,k0,tf,rho,inv_vc,weights,opts);
                        
pause(rand)


solx0       = solx1;


save solx_revall16_step2.mat solx1 fval1

                        
end




