%%%%%%%%%%%%%%%%%%%%%%% This file computes the standard errors; %%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%% does figures 2,3 and 4;                 %%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%% and performs the counterfactuals.       %%%%%%%%%%%

clc
clear

warning off



options   = optimset('Display','iter','MaxFunEvals',20000,'MaxIter',10000);
options2  = optimset('Display','off','MaxFunEvals',20000,'MaxIter',5000);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  loading frist step parameters

load solx_revall16.mat solx1 




solx0 = solx1;

%%%%%%%%%%%%%

imax        = 100;
maxt        = 120;
     
A           = 9687;
md          = 1000; 
k0          = 150000;
tf          = 160;

f           = 12;
h           = 5;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% fixed parameters
rho     =    .015; % quarterly data
delta1  =       1;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Infile data %%%%%%%%%%%%%%
[avgage, forsale, active, rtrans, dtrans, deal_inv, tdate, make_model] = textread('samplest_rev1.txt', '%n %n %n %n %n %n %n %n','delimiter',',');


[pr, pw, dpr, dpw, qage] = textread('pricev2_2.txt', '%n %n %n %n %n','delimiter',',','emptyvalue',999);

data_p = [pr, pw, dpr, dpw, qage];

data_p = data_p(qage<=maxt,:);

pr = data_p(:,1);

pw = data_p(:,2);

qage = data_p(:,5);

[nobsp,nvarsp] = size(data_p);

for i=1:maxt+1
    pr_e(i) = mean(pr(qage==i-1));
end



data_q = [forsale, deal_inv, (rtrans-dtrans), dtrans, avgage, active];

[nobsq,nvarsq] = size(data_q);


lpr = log(pr);
lpw = log(pw);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% price regressions
p_data = [pr;pw];
lp_data = log(p_data);

nl = length(p_data);

dummy_pw = [zeros(nl/2,1);ones(nl/2,1)];

qagevec = [qage;qage];

x = [dummy_pw,qagevec];



beta0 = [-2542121;2542121+(-2440869);2.01e+07;-2.01e+07+1.80e+07;.0151;0];

beta = fminsearch('pnlfit',beta0,options,p_data,x);





modelfun = @(b,x) ((b(1)+b(2)*x(:,1)) + (b(3)+b(4)*x(:,1)).*exp(-(b(5)+b(6)*x(:,1)).*x(:,2)));

opts                = statset('nlinfit');
opts.Display        = 'off';


x = [dummy_pw,qagevec];

beta0 = beta;
[beta1,R,J,cov_beta,mse] = nlinfit(x,p_data,modelfun,beta0,opts);




beta_vec = [beta1(1)+beta1(3);beta1(1)+beta1(2)+beta1(3)+beta1(4);beta1(3);beta1(3)+beta1(4);beta1(5);beta1(5)+beta1(6)];



rdtrans     = rtrans-dtrans;



% parameter solutions from first-step estimation
 
b = solx1;


t0 = 0;


lambda      = exp(b(1)); 
gamma_s     = exp(b(2)); 
gamma_sd    = exp(b(3)); 
alpha_ds    = exp(b(4)); 

delta2      = exp(b(5)); 
zh          = exp(b(6)); 
zl          = exp(b(7)); 
cs          = exp(b(8)); 
thetas      = exp(b(9))/(1+exp(b(9))); 
thetad      = exp(b(10))/(1+exp(b(10))); 


cs_first = cs;

tspan1 = t0:1:tf;
tspan1 = tspan1';



a1 = ones(length(tspan1),1);
a2 = a1;
a3 = a1;
a4 = a1;
a5 = a1;
a6 = a1;


flowx = A/tf;



mdo = zeros(tf+1,1); mlo = zeros(tf+1,1);

mho(2:tf+1,1) = flowx - mdo(2:tf+1) - mlo(2:tf+1);

mho(1) = flowx; mlo(1) = 0; mdo(1) = 0; 


mdn         = max(md - sum(mdo),0);




tspan2 = tf+t0-tspan1;
tspan2 = tspan2';




jdn_m    = 0;
vln_m    = 0;
pscrap   = 0;

delta1 = 1; delta0 = 0;

    d3 = 100; d4 = 100; d5 = 100;
    i  = 0; 

    options1 = [];
    %scraph2  = tf;



 
       while (d3>0.005 || d4>.01) && i<imax 

            aa1 = flipdim(a1,1); aa2 = flipdim(a2,1); aa3 = flipdim(a3,1); 
            aa4 = flipdim(a4,1); aa5 = flipdim(a5,1); aa6 = flipdim(a6,1); 

            %scraph = min(max(find(aa2==1)),tf);
            %scrapd = min(max(find(aa5==1)),tf);

            gammaprime  = gamma_sd / mdn;
            mhn         = alpha_ds / gammaprime;
            gamma       = gamma_s  / mhn;        



            mho2 = mho;
            mlo2 = mlo;


            X1 = [0 flowx]';
            
            [t1,y1]=ode45(@masses6,tspan1,X1,options1,mhn,gamma_s,gamma_sd,...
                          flowx,gamma,gammaprime,lambda,aa1,aa2,aa3,aa4,aa5,aa6,tf);

            mho = y1(:,2).*aa2; mlo = y1(:,1); mdo = max((flowx - mlo - mho).*aa5,0);



            scraph = min(max(find(mho>0)),tf);
            %scrapd = min(max(find(mdo>0)),tf);




            gamma_b  = gamma*mlo.*aa1;
            gamma_bd = gammaprime*mdo.*aa5;
            alpha_db = gammaprime*mlo.*aa1;

            mdn  = max(md - sum(mdo),0);



            gamma_bb  = flipdim(gamma_b,1);  gamma_bdd = flipdim(gamma_bd,1); 
            alpha_dbb = flipdim(alpha_db,1);

            d0 = 100; d4 = 100; 
            i2 = 0;

            vhn_calc = 0;



            while d0>0.005 && i2<imax  


            vhn_m = vhn_calc; k = k0;
            %%%%% terminal condition
            X0 = [0 0 0 0 vhn_m+pscrap pscrap jdn_m+pscrap]';


            [t2,y2]=ode45(@fun_my4,tspan2,X0,options1, lambda, gamma_s, gamma_sd, ...
                          alpha_ds, delta0, delta1, delta2, zh, zl, vhn_m, cs, pscrap, k0, rho, thetas, thetad);

            p  = (1-thetas)*(y2(:,6) - vln_m) + thetas*(y2(:,5) - vhn_m);
            pb = (1-thetad)*(y2(:,7) - jdn_m) + thetad*(y2(:,6) - vln_m);
            pa = (1-thetad)*(y2(:,7) - jdn_m) + thetad*(y2(:,5) - vhn_m);
            


            vhn_calc  = (- cs  + sum(gamma_bb  .* max(y2(:,5) - p  - vhn_m,0)) ...
                               + sum(gamma_bdd .* max(y2(:,5) - pa - vhn_m,0))) /(rho+lambda);

            k0        =   sum (alpha_dbb.* max(y2(:,7) - pb- jdn_m,0));


            d1 = [abs(vhn_calc./vhn_m-1),abs((k0+1)./(k+1)-1),any(isnan(p)),isnan(vhn_calc),isnan(k0)];
            
            d0 = max([d1,isnan(d1)]);
            
            d4 = min(d4,d0);
            
            if d4 == d0
                
            vhn_m1 = vhn_calc;
            
            a1 = (y2(:,2) >= y2(:,3));
            a2 = (y2(:,1) >= pscrap*ones(length(t2),1)+vhn_m1);
            a3 = (y2(:,5) - pa - vhn_m1>=0);
            a4 = (y2(:,7) - pb - jdn_m>=0);
            a5 = (y2(:,7) >= (pscrap+jdn_m)*ones(length(t2),1));
            a6 = (y2(:,5) - p - vhn_m1>=0);
            
            p1  = p;
            pb1 = pb;
            k1  = k0;
            
            end
 
            i2=i2+1;



            end
            
            
       
            
            s1 = scraph;
            d2 = [mean(abs(mlo(2:s1)./mlo2(2:s1)-1)),mean(abs(mho(1:s1)./mho2(1:s1)-1)),...
                  sum(isnan(mlo)),sum(isnan(mho)),100*isempty(s1),100*isnan(s1)];
              
            d3 = min(100,max(d2));
            
            d5 = min(d5,d3);
            
            if d5 == d3 
                mho1 = mho; mhn1 = mhn; mlo1 = mlo; mdo1 = mdo; a11 = a1; k11 = k1; p11 = p1; pb11 = pb1;
            end

            i = i+1;
            
       end
        

    
    
mho = mho1; mhn = mhn1; mlo = mlo1; mdo = mdo1; p = p11; pb = pb11;  a1 = a11; k = k11;
                   
mu = lambda*(sum(mho) + mhn);




pp  = flipdim(p,1);
ppb = flipdim(pb,1);

aa1 = flipdim(a1,1);

mlo_fors = mlo.*aa1;

assets = sum(mlo+mdo+mho);     



%%%%%%%%% simulate prices
pr_sim = pp(1:maxt+1);
pw_sim = ppb(1:maxt+1);

p_sim = [pr_sim;pw_sim];
lp_sim =log(p_sim);

nl = length(p_sim);

dummy_sim = [zeros(nl/2,1);ones(nl/2,1)];

qagevec_sim = [(0:1:maxt)';(0:1:maxt)'];

x_sim = [dummy_sim,qagevec_sim];

beta0 = [beta_vec(1) - beta_vec(3);  beta_vec(2) - beta_vec(1) - beta_vec(3) - beta_vec(4); ...
         beta_vec(3); - beta_vec(3) + beta_vec(4); beta_vec(5); -beta_vec(5)+beta_vec(6)];


beta_sim = fminsearch('pnlfit',beta0,options2,p_sim,x_sim);
beta_sim = fminsearch('pnlfit',beta_sim,options2,p_sim,x_sim);
beta_sim = fminsearch('pnlfit',beta_sim,options2,p_sim,x_sim);



beta0 = beta_sim;
beta_sim = nlinfit(x_sim,p_sim,modelfun,beta0,opts);


beta_vec_sim = [beta_sim(1)+beta_sim(3);...
                beta_sim(1)+beta_sim(2)+beta_sim(3)+beta_sim(4);...
                beta_sim(3);...
                beta_sim(3)+beta_sim(4);...
                beta_sim(5);beta_sim(5)+beta_sim(6)];
            
            
            
%%%%%%%%%%%%%%%








constr = [(zh<zl);(vhn_calc<0);(cs>k);(mu/lambda<flowx*(tf+1)/1.1)];


    

    
weights = active;    
vc = zeros(11,11);        


% second-step estimation with optimal weighting matrix including covariance

data_qp1 = [(forsale./active) / (sum(mlo_fors+mdo)/assets)                                   - 1, ...
            (deal_inv./active) / (sum(mdo)/assets)                                           - 1, ...
            (rdtrans./active) / (gamma_s*sum(mlo_fors)/assets)                               - 1, ...
            (dtrans./active) / (alpha_ds*sum(mdo)/assets)                                    - 1, ...
            avgage./(sum(tspan1.*(mlo_fors+mdo))/sum(mlo_fors+mdo))                          - 1];

        

        
vc(1:5,1:5) = weightedcov(data_qp1,weights);      

grad_vec = [1,1,0,0,0,0;...
            0,1,0,0,0,0;...
            1,1,1,1,0,0;...
            0,1,0,1,0,0;...
            0,0,0,0,1,1;...
            0,0,0,0,0,1];
        
Amat = ((1./beta_vec_sim)*ones(1,6))';        
    
cov_beta_p = (grad_vec.*Amat)'*cov_beta*(grad_vec.*Amat);
       


vc(6:11,6:11) = cov_beta_p; 

inv_vc = inv(vc);

g_first_step = [wmean(data_qp1,weights*ones(1,5))';(beta_vec./beta_vec_sim-1)];
f_first_step = sum(g_first_step.^2);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[rv,cv] = size(vc);

load solx_revall16_step2.mat solx1

deriv = zeros(length(solx1),rv);
 
for i = 1:length(solx1)
    
    smallh = zeros(length(solx1),1);
    
    smallh(i) = solx1(i)*.01;

    [f3,g3] = mp_new23(solx1+smallh,forsale,deal_inv,dtrans,rdtrans,avgage,active,A,md,...
                            beta_vec,maxt,imax,k0,tf,rho,inv_vc,weights,opts);    
    
    [f4,g4] = mp_new23(solx1-smallh,forsale,deal_inv,dtrans,rdtrans,avgage,active,A,md,...
                            beta_vec,maxt,imax,k0,tf,rho,inv_vc,weights,opts);  
    
        
    deriv(i,:) = (g3-g4)./(2*smallh(i));
end


varcov1 = inv(deriv*inv_vc*deriv');




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% second step

b = solx1;


t0 = 0;


lambda      = exp(b(1));
gamma_s     = exp(b(2));
gamma_sd    = exp(b(3));
alpha_ds    = exp(b(4));

delta2      = exp(b(5)); 
zh          = exp(b(6)); %zh = 650000;
zl          = exp(b(7)); %zl = 300000;
cs          = exp(b(8)); %cs = 30000;
thetas      = exp(b(9))/(1+exp(b(9)));
thetad      = exp(b(10))/(1+exp(b(10)));



tspan1 = t0:1:tf;
tspan1 = tspan1';



a1 = ones(length(tspan1),1);
a2 = a1;
a3 = a1;
a4 = a1;
a5 = a1;
a6 = a1;


flowx = A/tf;



mdo = zeros(tf+1,1); mlo = zeros(tf+1,1);

mho(2:tf+1,1) = flowx - mdo(2:tf+1) - mlo(2:tf+1);

mho(1) = flowx; mlo(1) = 0; mdo(1) = 0; 


mdn         = max(md - sum(mdo),0);




tspan2 = tf+t0-tspan1;
tspan2 = tspan2';




jdn_m    = 0;
vln_m    = 0;
pscrap   = 0;

delta1 = 1; delta0 = 0;

    d3 = 100; d4 = 100; d5 = 100;
    i  = 0; 

    options1 = [];
    %scraph2  = tf;



 
       while (d3>0.005 || d4>.01) && i<imax 

            aa1 = flipdim(a1,1); aa2 = flipdim(a2,1); aa3 = flipdim(a3,1); 
            aa4 = flipdim(a4,1); aa5 = flipdim(a5,1); aa6 = flipdim(a6,1); 



            gammaprime  = gamma_sd / mdn;
            mhn         = alpha_ds / gammaprime;
            gamma       = gamma_s  / mhn;        



            mho2 = mho;
            mlo2 = mlo;


            X1 = [0 flowx]';
            
            [t1,y1]=ode45(@masses6,tspan1,X1,options1,mhn,gamma_s,gamma_sd,...
                          flowx,gamma,gammaprime,lambda,aa1,aa2,aa3,aa4,aa5,aa6,tf);

            mho = y1(:,2).*aa2; mlo = y1(:,1); mdo = max((flowx - mlo - mho).*aa5,0);



            scraph = min(max(find(mho>0)),tf);
           


            gamma_b  = gamma*mlo.*aa1;
            gamma_bd = gammaprime*mdo.*aa5;
            alpha_db = gammaprime*mlo.*aa1;

            mdn  = max(md - sum(mdo),0);



            gamma_bb  = flipdim(gamma_b,1);  gamma_bdd = flipdim(gamma_bd,1); 
            alpha_dbb = flipdim(alpha_db,1);

            d0 = 100; d4 = 100; 
            i2 = 0;

            vhn_calc = 0;



            while d0>0.005 && i2<imax  


            vhn_m = vhn_calc; k = k0;
            %%%%% terminal condition
            X0 = [0 0 0 0 vhn_m+pscrap pscrap jdn_m+pscrap]';


            [t2,y2]=ode45(@fun_my4,tspan2,X0,options1, lambda, gamma_s, gamma_sd, ...
                          alpha_ds, delta0, delta1, delta2, zh, zl, vhn_m, cs, pscrap, k0, rho, thetas, thetad);

            p  = (1-thetas)*(y2(:,6) - vln_m) + thetas*(y2(:,5) - vhn_m);
            pb = (1-thetad)*(y2(:,7) - jdn_m) + thetad*(y2(:,6) - vln_m);
            pa = (1-thetad)*(y2(:,7) - jdn_m) + thetad*(y2(:,5) - vhn_m);
            


            vhn_calc  = (- cs  + sum(gamma_bb  .* max(y2(:,5) - p  - vhn_m,0)) ...
                               + sum(gamma_bdd .* max(y2(:,5) - pa - vhn_m,0))) /(rho+lambda);

            k0        =   sum (alpha_dbb.* max(y2(:,7) - pb- jdn_m,0));


            d1 = [abs(vhn_calc./vhn_m-1),abs((k0+1)./(k+1)-1),any(isnan(p)),isnan(vhn_calc),isnan(k0)];
            
            d0 = max([d1,isnan(d1)]);
            
            d4 = min(d4,d0);
            
            if d4 == d0
                
            vhn_m1 = vhn_calc;
            
            a1 = (y2(:,2) >= y2(:,3));
            a2 = (y2(:,1) >= pscrap*ones(length(t2),1)+vhn_m1);
            a3 = (y2(:,5) - pa - vhn_m1>=0);
            a4 = (y2(:,7) - pb - jdn_m>=0);
            a5 = (y2(:,7) >= (pscrap+jdn_m)*ones(length(t2),1));
            a6 = (y2(:,5) - p - vhn_m1>=0);        
            
            p1  = p;
            pb1 = pb;
            k1  = k0;
            
            end
 
            i2=i2+1;



            end
            
            
       
            
            s1 = scraph;
            d2 = [mean(abs(mlo(2:s1)./mlo2(2:s1)-1)),mean(abs(mho(1:s1)./mho2(1:s1)-1)),...
                  sum(isnan(mlo)),sum(isnan(mho)),100*isempty(s1),100*isnan(s1)];
              
            d3 = min(100,max(d2));
            
            d5 = min(d5,d3);
            
            if d5 == d3 
                mho1 = mho; mhn1 = mhn; mlo1 = mlo; mdo1 = mdo; a11 = a1; k11 = k1; p11 = p1; pb11 = pb1;
            end

            i = i+1;
            
       end
        

    
    
mho = mho1; mhn = mhn1; mlo = mlo1; mdo = mdo1; p = p11; pb = pb11;  a1 = a11; k = k11;
                   
mu = lambda*(sum(mho) + mhn);



pp  = flipdim(p,1);
ppb = flipdim(pb,1);

aa1 = flipdim(a1,1);
aa3 = flipdim(a3,1);
aa4 = flipdim(a4,1);


mlo_fors = mlo.*aa1;

assets = sum(mlo+mdo+mho);     



%%%%%%%%% simulate prices
pr_sim = pp(1:maxt+1);
pw_sim = ppb(1:maxt+1);

p_sim = [pr_sim;pw_sim];


nl = length(p_sim);

dummy_sim = [zeros(nl/2,1);ones(nl/2,1)];

qagevec_sim = [(0:1:maxt)';(0:1:maxt)'];

x_sim = [dummy_sim,qagevec_sim];

beta0 = [beta_vec(1) - beta_vec(3);  beta_vec(2) - beta_vec(1) - beta_vec(3) - beta_vec(4); ...
         beta_vec(3); - beta_vec(3) + beta_vec(4); beta_vec(5); -beta_vec(5)+beta_vec(6)];


beta_sim = fminsearch('pnlfit',beta0,options2,p_sim,x_sim);
beta_sim = fminsearch('pnlfit',beta_sim,options2,p_sim,x_sim);
beta_sim = fminsearch('pnlfit',beta_sim,options2,p_sim,x_sim);



beta0 = beta_sim;
beta_sim = nlinfit(x_sim,p_sim,modelfun,beta0,opts);


beta_vec_sim = [beta_sim(1)+beta_sim(3);...
                beta_sim(1)+beta_sim(2)+beta_sim(3)+beta_sim(4);...
                beta_sim(3);...
                beta_sim(3)+beta_sim(4);...
                beta_sim(5);beta_sim(5)+beta_sim(6)];


% second-step estimation with optimal weighting matrix including covariance

weights = active;    


% second-step estimation with optimal weighting matrix including covariance

data_qp1 = [(forsale./active) / (sum(mlo_fors+mdo)/assets)                                   - 1, ...
            (deal_inv./active) / (sum(mdo)/assets)                                           - 1, ...
            (rdtrans./active) / (gamma_s*sum(mlo_fors)/assets)                               - 1, ...
            (dtrans./active) / (alpha_ds*sum(mdo)/assets)                                    - 1, ...
            avgage./(sum(tspan1.*(mlo_fors+mdo))/sum(mlo_fors+mdo))                          - 1];

        
vc2 = zeros(11,11);              

        
vc2(1:5,1:5) = weightedcov(data_qp1,weights)/length(active);      

grad_vec = [1,1,0,0,0,0;...
            0,1,0,0,0,0;...
            1,1,1,1,0,0;...
            0,1,0,1,0,0;...
            0,0,0,0,1,1;...
            0,0,0,0,0,1];
        
Amat = ((1./beta_vec_sim)*ones(1,6))';        
    
cov_beta_p = (grad_vec.*Amat)'*cov_beta*(grad_vec.*Amat);
       


vc2(6:11,6:11) = cov_beta_p/length(pr); 

inv_vc2 = inv(vc2);


varcov2 = varcov1*(deriv*inv_vc*vc2*inv_vc*deriv')*varcov1;

grad = zeros(length(solx1),length(solx1));

for i=1:length(solx1)
    if i<=8
    grad(i,i) = exp(solx1(i));
    else
    grad(i,i) = exp(solx1(i))/((1+exp(solx1(i)))^2);    
    end
end

varcov3 = transpose(grad)*varcov2*grad;

for i=1:length(solx1)
    sd(i) = varcov3(i,i).^.5;
end

disp('standard errors done')
save solx_revall16_step2.mat sd -append
        




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% some plots

%%%% This is figure 2 in the paper

figure(1)


plot(1:maxt+1,(pr_e(1:maxt+1)),'r--','linewidth',h)
hold on
plot(1:maxt+1,(pr_sim(1:maxt+1)),'b','linewidth',h)
hold off

ylabel('Retail Price (millions)','FontSize',f)
xlabel('Years of Age','FontSize',f)
set(gca,'xTick',[1 21 41 61 81],'XTickLabel',[0 5 10 15 20],'FontSize',f)
set(gca,'yTick',[0 5 10 15 20]*10^6,'YTickLabel',[0 5 10 15 20],'FontSize',f)
axis([1 81 0*10^6 20*10^6])

grid on

%laprint(1,'pfit_rev1','factor',0.6,'scalefonts','off','keepfontprops','on','asonscreen','off')



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% welfare
        
        
maxage_om = max(find(aa1>0));

misa     = zeros(12,1);

misa(1)  = sum(mdo+mlo);
misa(2)  = sum(mdo+mlo)/assets;        
misa(3)  = sum(mdo+mlo_fors);
misa(4)  = sum(mdo+mlo_fors)/assets;        


aa = 0:1:maxt; aa = aa';        


vhn_base = vhn_calc;
vho_base = flipdim(y2(:,5),1);
vlo_base = flipdim(y2(:,6),1);
jdo_base = flipdim(y2(:,7),1);
jdn_base = jdn_m;




search_costs_base     = cs*(sum(mlo_fors)+mhn);
dealer_costs_base     = k*md;

allocations_base   = sum(mho.*zh.*(delta0 + delta1*exp(-delta2.*t1)) + ...
                         mlo.*zl.*(delta0 + delta1*exp(-delta2.*t1)));

welfare_base = allocations_base - search_costs_base - dealer_costs_base;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% now
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% counterfactuals

%%%%%%%%%%%%%%%%%%%%% walrasian

pwal1     = zh*(delta0*(1-exp(-rho*(tf-tspan1)))/rho + ...
            delta1*(exp(-delta2*tspan1)-(exp(rho*tspan1))*exp(-tf*(delta2+rho)))/(rho + delta2));
        
pgains1   = pwal1(1:maxt+1)./pr_sim(1:maxt+1);


allocations_w  = sum((zh.*flowx.*(delta0 + exp(-delta2.*t1))));

welfare_w = allocations_w;



%%%%%%%%%%%%%%%% split function

cs0 = 0; md0 = md;


 

options  = optimset('Display','iter','MaxFunEvals',5000,'MaxIter',100);

fwal0 = 10e11;
fwal1 = .5*fwal0;

lmd0 = log(1000);

while fwal0-fwal1>0

fwal0 = fwal1;

[lmd_noc,fwal1] = fminsearch('mp_new17_counter',lmd0,options,gamma,gammaprime,lambda,zh,zl,delta0,delta1,delta2,k,...
                cs0,tspan1,tf,t0,mu,flowx,imax,gamma_s,gamma_sd,alpha_ds,rho,thetas,thetad);


lmd0       = lmd_noc;
 
                       
end

md_noc = exp(lmd_noc);

a1 = ones(length(tspan1),1);
a2 = a1;
a3 = a1;
a4 = a1;
a5 = a1;
a6 = a1;





mdo_noc = zeros(tf+1,1); mlo_noc = zeros(tf+1,1);

mho_noc(2:tf+1,1) = flowx - mdo_noc(2:tf+1) - mlo_noc(2:tf+1);

mho_noc(1) = flowx; mlo_noc(1) = 0; mdo_noc(1) = 0; 



mhn_noc         = max(mu/lambda-sum(mho_noc),0); 

tspan2 = tf+t0-tspan1;
tspan2 = tspan2';


vln_m    = 0;
pscrap   = 0;

d3 = 100; d4 = 100; d5 = 100;
i  = 0; 

options1 = [];




 
       while (d3>0.005 || d4>.01) && i<imax 

            aa1 = flipdim(a1,1); aa2 = flipdim(a2,1); aa3 = flipdim(a3,1); 
            aa4 = flipdim(a4,1); aa5 = flipdim(a5,1); aa6 = flipdim(a6,1); 

            %scraph = min(max(find(aa2==1)),tf);
            %scrapd = min(max(find(aa5==1)),tf);


            mho_noc2 = mho_noc;
            mlo_noc2 = mlo_noc;
            mhn_noc0 = mhn_noc;

            X1 = [0 flowx]';
            
            [t1,y1]=ode45(@masses6,tspan1,X1,options1,mhn_noc,gamma_s,gamma_sd,...
                          flowx,gamma,gammaprime,lambda,aa1,aa2,aa3,aa4,aa5,aa6,tf);

            mho_noc = y1(:,2).*aa2; mlo_noc = y1(:,1); mdo_noc = max((flowx - mlo_noc - mho_noc).*aa5,0);



            scraph = min(max(find(mho_noc>0)),tf);
            %scrapd = min(max(find(mdo>0)),tf);

            mdn_noc     = max(md_noc - sum(mdo_noc),0);
            mhn_noc     = max(mu/lambda-sum(mho_noc),0); 

            gamma_sd    = gammaprime * mdn_noc;
            alpha_ds    = gammaprime * mhn_noc;
            gamma_s     = gamma * mhn_noc; 

            gamma_b  = gamma*mlo_noc.*aa1;
            gamma_bd = gammaprime*mdo_noc.*aa5;
            alpha_db = gammaprime*mlo_noc.*aa1;






            gamma_bb  = flipdim(gamma_b,1);  gamma_bdd = flipdim(gamma_bd,1); 
            alpha_dbb = flipdim(alpha_db,1);

            d0 = 100; 
            i2 = 0;
            vhn_calc = 0;
            jdn_m = 0;



            while d0>0.005 && i2<imax  


            vhn_m = vhn_calc; 
            %%%%% terminal condition
            X0 = [0 0 0 0 vhn_m+pscrap pscrap jdn_m+pscrap]';


            [t2,y2]=ode45(@fun_my4,tspan2,X0,options1, lambda, gamma_s, gamma_sd, ...
                          alpha_ds, delta0, delta1, delta2, zh, zl, vhn_m, cs, pscrap, k, rho, thetas, thetad);

            p  = (1-thetas)*(y2(:,6) - vln_m) + thetas*(y2(:,5) - vhn_m);
            pb = (1-thetad)*(y2(:,7) - jdn_m) + thetad*(y2(:,6) - vln_m);
            pa = (1-thetad)*(y2(:,7) - jdn_m) + thetad*(y2(:,5) - vhn_m);
            


            vhn_calc  = (- cs  + sum(gamma_bb  .* max(y2(:,5) - p  - vhn_m,0)) ...
                               + sum(gamma_bdd .* max(y2(:,5) - pa - vhn_m,0))) /(rho+lambda);

            jdn_calc      =  - k + sum (alpha_dbb.* max(y2(:,7) - pb- jdn_m,0));

                
            d1 = [abs(vhn_calc./vhn_m-1),any(isnan(p)),isnan(vhn_calc)];
            
            d0 = max([d1,isnan(d1)]);
            
            d4 = min(d4,d0);
            
            if d4 == d0
                
            vhn_m1 = vhn_calc;
            
            a1 = (y2(:,2) >= y2(:,3));
            a2 = (y2(:,1) >= pscrap*ones(length(t2),1)+vhn_m1);
            a3 = (y2(:,5) - pa - vhn_m1>=0);
            a4 = (y2(:,7) - pb - jdn_m>=0);
            a5 = (y2(:,7) >= (pscrap+jdn_m)*ones(length(t2),1));
            a6 = (y2(:,5) - p - vhn_m1>=0);
            
            p1  = p;
            pb1 = pb;

            
            end
 
            i2=i2+1;



            end
            
            
       
            
            s1 = scraph;
            d2 = [mean(abs(mlo_noc(2:s1)./mlo_noc2(2:s1)-1)),mean(abs(mho_noc(1:s1)./mho_noc2(1:s1)-1)),...
                  sum(isnan(mlo_noc)),sum(isnan(mho_noc)),100*isempty(s1),100*isnan(s1)];
              
            d3 = min(100,max(d2));
            
            d5 = min(d5,d3);
            
            if d5 == d3 
                mho_noc1 = mho_noc; mhn_noc1 = mhn_noc; mlo_noc1 = mlo_noc; mdo_noc1 = mdo_noc; 
                a11 = a1; p11 = p1; pb11 = pb1;
            end

            i = i+1;
            
       end
       
mho_noc = mho_noc1; mhn_noc = mhn_noc1; mlo_noc = mlo_noc1; mdo_noc = mdo_noc1;
a1 = a11; p1 = p11; pb1 = pb11;

i
i2
   
pp2  = flipdim(p1,1);
ppb2 = flipdim(pb1,1);
pnoc = pp2;

aa1 = flipdim(a1,1);

mlo_noc_fs = mlo_noc.*aa1;
assets_noc = sum(mlo_noc+mdo_noc+mho_noc); 

misa(5)  = sum(mdo_noc+mlo_noc);
misa(6)  = sum(mdo_noc+mlo_noc)/assets_noc;    

misa(7)  = sum(mdo_noc+mlo_noc_fs);
misa(8)  = sum(mdo_noc+mlo_noc_fs)/assets_noc;     


allocations_noc  = sum(mho_noc.*zh.*(delta0 + delta1*exp(-delta2.*t1)) + ...
                       mlo_noc.*zl.*(delta0 + delta1*exp(-delta2.*t1)));

search_costs_noc     = 0;

dealer_costs_noc     = k*md_noc;

welfare_noc = allocations_noc - search_costs_noc - dealer_costs_noc;

code=['save solx_revall16_counter.mat welfare_base allocations_base search_costs_base dealer_costs_base allocations_w welfare_noc allocations_noc search_costs_noc dealer_costs_noc'];
eval(code)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% figure 3 in the paper


figure(2)


plot(1:maxt+1,pwal1(1:maxt+1),'r--','linewidth',h)
hold on
plot(1:maxt+1,pp2(1:maxt+1),'k-.','linewidth',h)
hold on
plot(1:maxt+1,pr_sim(1:maxt+1),'b','linewidth',h)
hold off

ylabel('Retail Price (millions)','FontSize',f)
xlabel('Years of Age','FontSize',f)
set(gca,'xTick',[1 21 41 61 81],'XTickLabel',[0 5 10 15 20 25],'FontSize',f)
set(gca,'yTick',[0 5 10 15 20 25]*10^6,'YTickLabel',[0 5 10 15 20 25],'FontSize',f)
axis([1 81 0*10^6 25*10^6])

grid on

%laprint(2,'pwal_rev1','factor',0.6,'scalefonts','off','keepfontprops','on','asonscreen','off')





%%%%%%%%%%%%%%%%%%%%%%%%% no dealers


a1 = ones(length(tspan1),1);
a2 = a1;
a3 = a1;


mlo_nod = zeros(tf+1,1);

mho_nod(2:tf+1,1) = flowx - mlo_nod(2:tf+1);

mho_nod(1) = flowx; mlo_nod(1) = 0;


mhn_nod         = max(mu/lambda-sum(mho_nod),0); 

tspan2 = tf+t0-tspan1;
tspan2 = tspan2';



vhn_calc = 10000;
vln_m    = 0;
pscrap   = 0;

options1 = [];

d3 = 100; d4 = 100; d5 = 100;
i  = 0; 

imax = 100;


while (d3>0.005 || d4>.01) && i<imax 
        
    aa1 = flipdim(a1,1); aa2 = flipdim(a2,1); aa3 = flipdim(a3,1); 




    mho_nod2 = mho_nod;
    mlo_nod2 = mlo_nod;


    X1 = [flowx]';


    [t1,y1]=ode45(@masses7,tspan1,X1,options1,mhn_nod,flowx,gamma,lambda,aa1,aa2,aa3,tf);

    mho_nod = y1(:,1).*aa2; mlo_nod = max((flowx - mho_nod),0);



    scraph = min(max(find(mho_nod>0)),tf);
    %scrapd = min(max(find(mdo>0)),tf);




    gamma_b  = gamma*mlo_nod.*aa1;


    mhn_nod     = max(mu/lambda-sum(mho_nod),0);    



    gamma_bb  = flipdim(gamma_b,1);

    d0 = 100; 
    i2 = 0;        
            
        while d0>0.005 && i2<imax  

        gamma_s     = gamma * mhn_nod;  

        vhn_m = vhn_calc;
        %%%%% terminal condition
        X0 = [0 0 0 vhn_m+pscrap pscrap]';

        [t2,y2]=ode23(@fun_my5,tspan2,X0,options1, lambda, gamma_s,...
                      delta0, delta1, delta2, zh, zl, vhn_m, cs, pscrap,rho,thetas,thetad);

        p  = (1-thetas)*(y2(:,5) - vln_m) + thetas*(y2(:,4) - vhn_m);

        vhn_calc = (- cs  + sum(gamma_bb  .* max(y2(:,5) - p  - vhn_m,0))) /(rho+lambda);

        d1 = [abs(vhn_calc./vhn_m-1),any(isnan(p)),isnan(vhn_calc),isnan(k0)];

        d0 = max([d1,isnan(d1)]);

        d4 = min(d4,d0);

            if d4 == d0


            a1 = (y2(:,2) >= y2(:,3));
            a2 = (y2(:,1) >= pscrap*ones(length(t2),1)+vhn_calc);
            a3 = (y2(:,4) - p - vhn_m>=0);


            p1  = p;

            end

        i2 = i2+1;

        end

    s1 = scraph;
    d2 = [mean(abs(mlo_nod(2:s1)./mlo_nod2(2:s1)-1)),mean(abs(mho_nod(1:s1)./mho_nod2(1:s1)-1)),...
          100*isempty(s1),100*isnan(s1)];

    d3 = min(100,max(d2));

    d5 = min(d5,d3);

        if d5 == d3 
            mho_nod1 = mho_nod; mhn_nod1 = mhn_nod; mlo_nod1 = mlo_nod; a11 = a1; p11 = p1; 
        end

    i = i+1;

   end  

mho_nod = mho_nod1; mhn_nod = mhn_nod1; mlo_nod = mlo_nod1; p1 = p11; a1 = a11; 

vhn_nod = vhn_calc;
vho_nod = flipdim(y2(:,4),1);
vlo_nod = flipdim(y2(:,5),1);

assets_nod = sum(mlo_nod+mho_nod);   

aa1 = flipdim(a1,1);

mlo_nod_fs = mlo_nod.*aa1;

misa(9)   = sum(mlo_nod);
misa(10)  = sum(mlo_nod)/assets_nod;     
misa(11)  = sum(mlo_nod_fs);
misa(12)  = sum(mlo_nod_fs)/assets_nod;  
pnod      = flipdim(p1,1);


pgains2  = pnod(1:maxt+1)./pr_sim(1:maxt+1);


allocations_nod  = sum(mho_nod.*zh.*(delta0 + delta1*exp(-delta2.*t1)) + ...
                       mlo_nod.*zl.*(delta0 + delta1*exp(-delta2.*t1)));

search_costs_nod     = cs*(sum(mlo_nod_fs)+mhn_nod);


welfare_nod = allocations_nod - search_costs_nod;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% figure 4 


figure(3)

plot(1:maxt+1,pnod(1:maxt+1),'r--','linewidth',h)
hold on
plot(1:maxt+1,pr_sim(1:maxt+1),'b','linewidth',h)
hold off

ylabel('Retail Price (millions)','FontSize',f)
xlabel('Years of Age','FontSize',f)
set(gca,'xTick',[1 21 41 61 81],'XTickLabel',[0 5 10 15 20],'FontSize',f)
set(gca,'yTick',[0 5 10 15 20]*10^6,'YTickLabel',[0 5 10 15 20],'FontSize',f)
axis([1 81 0*10^6 20*10^6])

grid on
%laprint(3,'pnd_rev1','factor',0.6,'scalefonts','off','keepfontprops','on','asonscreen','off')


