%%%%%%%%%%%%%%%%% This file generates figure 6 %%%%%%%%%%%%

clear

%close all

f = 12;

fmax = 500;

load region3.mat

md  = md_sol1.*(fval1 < fmax);

wf3 = wf1.*(fval1 > fmax) + wf2.*(fval1 < fmax);

figure(1)
surf(md)

figure(2)
surf(wf1./wf3)

figure(3)
we2 = (wf1./wf3>1);
we1 = (wf1./wf3==1);
we0 = (wf1./wf3<1);

ggrid2       = [1:49/19:50];
% thgrid      = [1:1:20]*.975/20;

for i=1:20
    for j=1:20
        if we1(i,j)==1
            wen(i,j)=NaN;
        end
    end
end

we3 = 20*we2 + 10*we0 + wen;

contour(thgrid,ggrid2,we2,1,'-k','Linewidth',2)
hold on 
contour(thgrid,ggrid2,we1,1,'-k','Linewidth',2)
hold off

%plot(.97,4,'r*','MarkerSize',10)

grid on
%axis square

set(gca,'xTick',[0:.25:1],'XTickLabel',[0:.25:1],'FontSize',f)
xlabel('Dealers'' Bargaining Parameter $\theta _{d}$','FontSize',f)

set(gca,'yTick',[12.5:12.5:50],'YTickLabel',[12.5:12.5:50],'FontSize',f)
ylabel('Meeting Rate $\gamma''/\gamma$','FontSize',f)

%text(.15,8,'No Dealer Entry','FontSize',15)
%text(.35,15,'Dealers Enter and Increase Welfare','FontSize',15)
%text(.65,10,'Dealers Enter and Decrease Welfare','FontSize',15)

we3(18,6) = 20; we3(12:13,5) = 20; we3(19,5) = 20; we3(15:16,3) = 20; 


figure(4)
contourf(thgrid,ggrid2,we3,1,'-k','Linewidth',2)
hold on
plot(th0,g0/ggrid(1),'r*','MarkerSize',10)
hold off

cmap = [.3,.3,.3; 0,0,0; .8,.8,.8];

colormap(cmap)

set(gca,'xTick',[min(thgrid),0.25,0.5,0.75,max(thgrid)],'XTickLabel',[0:.25:1],'FontSize',f)
xlabel('Dealers'' Bargaining Parameter $\theta _{d}$','FontSize',f)

set(gca,'yTick',[0:12.5:50],'YTickLabel',[0:12.5:50],'FontSize',f)
ylabel('Meeting Rate $\gamma''/\gamma$','FontSize',f)
axis([min(thgrid) max(thgrid) 0 50])


return
laprint(4,'region1','factor',1,'scalefonts','off','keepfontprops','on','asonscreen','off')

pause(5)
dos('move c:\ag562\Dropbox\search\Revision2\region1.eps c:\ag562\Dropbox\search\figures')


