%%%%%%%%%%%%%%% Figure 5; fourth row %%%%%%%%%%%%%%%%


clc
clear

warning off

addpath(genpath('/scratch/gavazza/jplv7'))
cd /scratch/gavazza/search

task_id = getenv('PBS_ARRAYID');
id2 = str2num(task_id);



%addpath C:\ag562\Dropbox\search

options   = optimset('Display','iter','MaxFunEvals',20000,'MaxIter',100);
options2  = optimset('Display','off','MaxFunEvals',20000,'MaxIter',5000);


load solx_revall16_step2.mat solx1


%%%%%%%%%%%%%

imax        = 100;
maxt        = 120;
     
A           = 9687;
md          = 1000; 
k0          = 150000;
tf          = 160;

f           = 12;
h           = 5;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% fixed parameters

rho     =    .015; % quarterly data
delta1  =       1;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% second step

b = solx1;


t0 = 0;


lambda      = exp(b(1));
gamma_s     = exp(b(2));
gamma_sd    = exp(b(3));
alpha_ds    = exp(b(4));

delta2      = exp(b(5)); 
zh          = exp(b(6)); %zh = 650000;
zl          = exp(b(7)); %zl = 300000;
cs          = exp(b(8)); %cs = 30000;
thetas      = exp(b(9))/(1+exp(b(9)));
thetad      = exp(b(10))/(1+exp(b(10))); 

tspan1 = t0:1:tf;
tspan1 = tspan1';



a1 = ones(length(tspan1),1);
a2 = a1;
a3 = a1;
a4 = a1;
a5 = a1;
a6 = a1;


flowx = A/tf;



mdo = zeros(tf+1,1); mlo = zeros(tf+1,1);

mho(2:tf+1,1) = flowx - mdo(2:tf+1) - mlo(2:tf+1);

mho(1) = flowx; mlo(1) = 0; mdo(1) = 0; 


mdn         = max(md - sum(mdo),0);




tspan2 = tf+t0-tspan1;
tspan2 = tspan2';




jdn_m    = 0;
vln_m    = 0;
pscrap   = 0;

delta1 = 1; delta0 = 0;

    d3 = 100; d4 = 100; d5 = 100;
    i  = 0; 

    options1 = [];
    %scraph2  = tf;



 
       while (d3>0.005 || d4>.01) && i<imax 

            aa1 = flipdim(a1,1); aa2 = flipdim(a2,1); aa3 = flipdim(a3,1); 
            aa4 = flipdim(a4,1); aa5 = flipdim(a5,1); aa6 = flipdim(a6,1); 

            %scraph = min(max(find(aa2==1)),tf);
            %scrapd = min(max(find(aa5==1)),tf);

            gammaprime  = gamma_sd / mdn;
            mhn         = alpha_ds / gammaprime;
            gamma       = gamma_s  / mhn;        



            mho2 = mho;
            mlo2 = mlo;


            X1 = [0 flowx]';
            
            [t1,y1]=ode45(@masses6,tspan1,X1,options1,mhn,gamma_s,gamma_sd,...
                          flowx,gamma,gammaprime,lambda,aa1,aa2,aa3,aa4,aa5,aa6,tf);

            mho = y1(:,2).*aa2; mlo = y1(:,1); mdo = max((flowx - mlo - mho).*aa5,0);



            scraph = min(max(find(mho>0)),tf);
            %scrapd = min(max(find(mdo>0)),tf);




            gamma_b  = gamma*mlo.*aa1;
            gamma_bd = gammaprime*mdo.*aa5;
            alpha_db = gammaprime*mlo.*aa1;

            mdn  = max(md - sum(mdo),0);



            gamma_bb  = flipdim(gamma_b,1);  gamma_bdd = flipdim(gamma_bd,1); 
            alpha_dbb = flipdim(alpha_db,1);

            d0 = 100; d4 = 100; 
            i2 = 0;

            vhn_calc = 0;



            while d0>0.005 && i2<imax  


            vhn_m = vhn_calc; k = k0;
            %%%%% terminal condition
            X0 = [0 0 0 0 vhn_m+pscrap pscrap jdn_m+pscrap]';


            [t2,y2]=ode45(@fun_my4,tspan2,X0,options1, lambda, gamma_s, gamma_sd, ...
                          alpha_ds, delta0, delta1, delta2, zh, zl, vhn_m, cs, pscrap, k0, rho, thetas, thetad);

            p  = (1-thetas)*(y2(:,6) - vln_m) + thetas*(y2(:,5) - vhn_m);
            pb = (1-thetad)*(y2(:,7) - jdn_m) + thetad*(y2(:,6) - vln_m);
            pa = (1-thetad)*(y2(:,7) - jdn_m) + thetad*(y2(:,5) - vhn_m);
            


            vhn_calc  = (- cs  + sum(gamma_bb  .* max(y2(:,5) - p  - vhn_m,0)) ...
                               + sum(gamma_bdd .* max(y2(:,5) - pa - vhn_m,0))) /(rho+lambda);

            k0        =   sum (alpha_dbb.* max(y2(:,7) - pb- jdn_m,0));


            d1 = [abs(vhn_calc./vhn_m-1),abs((k0+1)./(k+1)-1),any(isnan(p)),isnan(vhn_calc),isnan(k0)];
            
            d0 = max([d1,isnan(d1)]);
            
            d4 = min(d4,d0);
            
            if d4 == d0
                
            vhn_m1 = vhn_calc;
            
            a1 = (y2(:,2) >= y2(:,3));
            a2 = (y2(:,1) >= pscrap*ones(length(t2),1)+vhn_m1);
            a3 = (y2(:,5) - pa - vhn_m1>=0);
            a4 = (y2(:,7) - pb - jdn_m>=0);
            a5 = (y2(:,7) >= (pscrap+jdn_m)*ones(length(t2),1));
            a6 = (y2(:,5) - p - vhn_m1>=0);        
            
            p1  = p;
            pb1 = pb;
            k1  = k0;
            
            end
 
            i2=i2+1;



            end
            
            
       
            
            s1 = scraph;
            d2 = [mean(abs(mlo(2:s1)./mlo2(2:s1)-1)),mean(abs(mho(1:s1)./mho2(1:s1)-1)),...
                  sum(isnan(mlo)),sum(isnan(mho)),100*isempty(s1),100*isnan(s1)];
              
            d3 = min(100,max(d2));
            
            d5 = min(d5,d3);
            
            if d5 == d3 
                mho1 = mho; mhn1 = mhn; mlo1 = mlo; mdo1 = mdo; a11 = a1; k11 = k1; p11 = p1; pb11 = pb1;
            end

            i = i+1;
            
       end
        

    
    
mho = mho1; mhn = mhn1; mlo = mlo1; mdo = mdo1; p = p11; pb = pb11;  a1 = a11; k = k11;
                   
mu = lambda*(sum(mho) + mhn);



pp  = flipdim(p,1);
ppb = flipdim(pb,1);

aa1 = flipdim(a1,1);
aa3 = flipdim(a3,1);
aa4 = flipdim(a4,1);


mlo_fors = mlo.*aa1;

assets = sum(mlo+mdo+mho);     




pr_sim = pp(1:maxt+1);
pw_sim = ppb(1:maxt+1);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% welfare
        
        
maxage_om = max(find(aa1>0));

misa     = zeros(12,1);

misa(1)  = sum(mdo+mlo);
misa(2)  = sum(mdo+mlo)/assets;        
misa(3)  = sum(mdo+mlo_fors);
misa(4)  = sum(mdo+mlo_fors)/assets;        


aa = 0:1:maxt; aa = aa';        


vhn_base = vhn_calc;
vho_base = flipdim(y2(:,5),1);
vlo_base = flipdim(y2(:,6),1);
jdo_base = flipdim(y2(:,7),1);
jdn_base = jdn_m;




search_costs_base     = cs*(sum(mlo_fors)+mhn);
dealer_costs_base     = k*md;

allocations_base   = sum(mho.*zh.*(delta0 + delta1*exp(-delta2.*t1)) + ...
                         mlo.*zl.*(delta0 + delta1*exp(-delta2.*t1)));

welfare_base = allocations_base - search_costs_base - dealer_costs_base;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% different
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% zh

thgrid = [1:1:20]*.975/20;

thetad = thgrid(id2);


code=['load th_robust.mat md_sol1 fval1'];
eval(code)


if id2>1
    md0 = log(md_sol1(id2-1)+.0001);
else
    md0 = - 1000;
end

%if fval1(id2)<100; fprintf('Results are good already'); exit; end;


fv0 = 10e11;
fv1 = .5*fv0;

    while fv1/fv0<1

    fv0 = fv1;


    [solx1, fv1]  = fminsearch('howmanyd',md0,options,t0,tf,flowx,mu,lambda,gammaprime,gamma,...
                delta0,delta1,delta2,zh,zl,cs,k,rho,thetas,thetad,imax,maxt);

    md0       = solx1;


    end


    

[~,out] = howmanyd(solx1,t0,tf,flowx,mu,lambda,gammaprime,gamma,...
                delta0,delta1,delta2,zh,zl,cs,k,rho,thetas,thetad,imax,maxt);
        
md_sol = exp(solx1);


fprintf('ALL DONE 1');

% if fv1>fval1(id2);fprintf('Previous results were better'); exit; end;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% now
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% counterfactuals

%%%%%%%%%%%%%%%%%%%%% walrasian

pwal1     = zh*(delta0*(1-exp(-rho*(tf-tspan1)))/rho + ...
            delta1*(exp(-delta2*tspan1)-(exp(rho*tspan1))*exp(-tf*(delta2+rho)))/(rho + delta2));
        
pgains1   = pwal1(1:maxt+1)./pr_sim(1:maxt+1);


allocations_w  = sum((zh.*flowx.*(delta0 + exp(-delta2.*t1))));

welfare_w = allocations_w;




%%%%%%%%%%%%%%%%%%%%%%%%% no dealers


a1 = ones(length(tspan1),1);
a2 = a1;
a3 = a1;


mlo_nod = zeros(tf+1,1);

mho_nod(2:tf+1,1) = flowx - mlo_nod(2:tf+1);

mho_nod(1) = flowx; mlo_nod(1) = 0;


mhn_nod         = max(mu/lambda-sum(mho_nod),0); 

tspan2 = tf+t0-tspan1;
tspan2 = tspan2';



vhn_calc = 10000;
vln_m    = 0;
pscrap   = 0;

options1 = [];

d3 = 100; d4 = 100; d5 = 100;
i  = 0; 

imax = 100;


while (d3>0.005 || d4>.01) && i<imax 
        
    aa1 = flipdim(a1,1); aa2 = flipdim(a2,1); aa3 = flipdim(a3,1); 




    mho_nod2 = mho_nod;
    mlo_nod2 = mlo_nod;


    X1 = [flowx]';


    [t1,y1]=ode45(@masses7,tspan1,X1,options1,mhn_nod,flowx,gamma,lambda,aa1,aa2,aa3,tf);

    mho_nod = y1(:,1).*aa2; mlo_nod = max((flowx - mho_nod),0);



    scraph = min(max(find(mho_nod>0)),tf);
    %scrapd = min(max(find(mdo>0)),tf);




    gamma_b  = gamma*mlo_nod.*aa1;


    mhn_nod     = max(mu/lambda-sum(mho_nod),0);    



    gamma_bb  = flipdim(gamma_b,1);

    d0 = 100; 
    i2 = 0;        
            
        while d0>0.005 && i2<imax  

        gamma_s     = gamma * mhn_nod;  

        vhn_m = vhn_calc;
        %%%%% terminal condition
        X0 = [0 0 0 vhn_m+pscrap pscrap]';

        [t2,y2]=ode23(@fun_my5,tspan2,X0,options1, lambda, gamma_s,...
                      delta0, delta1, delta2, zh, zl, vhn_m, cs, pscrap,rho,thetas,thetad);

        p  = (1-thetas)*(y2(:,5) - vln_m) + thetas*(y2(:,4) - vhn_m);

        vhn_calc = (- cs  + sum(gamma_bb  .* max(y2(:,5) - p  - vhn_m,0))) /(rho+lambda);

        d1 = [abs(vhn_calc./vhn_m-1),any(isnan(p)),isnan(vhn_calc),isnan(k0)];

        d0 = max([d1,isnan(d1)]);

        d4 = min(d4,d0);

            if d4 == d0


            a1 = (y2(:,2) >= y2(:,3));
            a2 = (y2(:,1) >= pscrap*ones(length(t2),1)+vhn_calc);
            a3 = (y2(:,4) - p - vhn_m>=0);


            p1  = p;

            end

        i2 = i2+1;

        end

    s1 = scraph;
    d2 = [mean(abs(mlo_nod(2:s1)./mlo_nod2(2:s1)-1)),mean(abs(mho_nod(1:s1)./mho_nod2(1:s1)-1)),...
          100*isempty(s1),100*isnan(s1)];

    d3 = min(100,max(d2));

    d5 = min(d5,d3);

        if d5 == d3 
            mho_nod1 = mho_nod; mhn_nod1 = mhn_nod; mlo_nod1 = mlo_nod; a11 = a1; p11 = p1; 
        end

    i = i+1;

   end  

mho_nod = mho_nod1; mhn_nod = mhn_nod1; mlo_nod = mlo_nod1; p1 = p11; a1 = a11; 

vhn_nod = vhn_calc;
vho_nod = flipdim(y2(:,4),1);
vlo_nod = flipdim(y2(:,5),1);

assets_nod = sum(mlo_nod+mho_nod);   

aa1 = flipdim(a1,1);

mlo_nod_fs = mlo_nod.*aa1;

misa(9)   = sum(mlo_nod);
misa(10)  = sum(mlo_nod)/assets_nod;     
misa(11)  = sum(mlo_nod_fs);
misa(12)  = sum(mlo_nod_fs)/assets_nod;  
pnod      = flipdim(p1,1);


pgains2  = pnod(1:maxt+1)./pr_sim(1:maxt+1);


allocations_nod  = sum(mho_nod.*zh.*(delta0 + delta1*exp(-delta2.*t1)) + ...
                       mlo_nod.*zl.*(delta0 + delta1*exp(-delta2.*t1)));

search_costs_nod     = cs*(sum(mlo_nod_fs)+mhn_nod);


welfare_nod = allocations_nod - search_costs_nod;


code=['load th_robust.mat wf1 wf2 md_sol1 fval1'];
eval(code)

wf1(id2) = out.welfare_base;

md_sol1(id2) = md_sol;

wf2(id2) = welfare_nod;

fval1(id2) = fv1;

code=['save th_robust.mat wf1 wf2 md_sol1 fval1 thgrid'];
eval(code)


fprintf('ALL DONE 2');
